searchNodes=[{"doc":"SweetXml is a thin wrapper around :xmerl . It allows you to convert a string or xmlElement record as defined in :xmerl to an elixir value such as map , list , char_list , or any combination of these. For normal sized documents, SweetXml primarily exposes 3 functions SweetXml.xpath/2 - return a value based on the xpath expression SweetXml.xpath/3 - similar to above but allowing nesting of mapping SweetXml.xmap/2 - return a map with keywords mapped to values returned from xpath For something larger, SweetXml mainly exposes 1 function SweetXml.stream_tags/3 - stream a given tag or a list of tags, and optionally &quot;discard&quot; some dom elements in order to free memory during streaming for big files which cannot fit entirely in memory Examples Simple Xpath: iex&gt; import SweetXml iex&gt; doc = &quot;&lt;h1&gt;&lt;a&gt;Some linked title&lt;/a&gt;&lt;/h1&gt;&quot; iex&gt; doc |&gt; xpath ( ~x&quot;//a/text()&quot; ) &#39;Some linked title&#39; Nested Mapping: iex&gt; import SweetXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc |&gt; xpath ( ~x&quot;//header&quot; , message : ~x&quot;./p/text()&quot; , a_in_li : ~x&quot;.//li/a/text()&quot;l ) %{ a_in_li : [ &#39;Two&#39; ] , message : &#39;Message&#39; } Streaming: iex&gt; import SweetXml iex&gt; doc = [ &quot;&lt;ul&gt;&lt;li&gt;l1&lt;/li&gt;&lt;li&gt;l2&quot; , &quot;&lt;/li&gt;&lt;li&gt;l3&lt;/li&gt;&lt;/ul&gt;&quot; ] iex&gt; SweetXml . stream_tags ( doc , :li ) ...&gt; |&gt; Stream . map ( fn { :li , doc } -&gt; ...&gt; doc |&gt; SweetXml . xpath ( ~x&quot;./text()&quot; ) ...&gt; end ) ...&gt; |&gt; Enum . to_list [ &#39;l1&#39; , &#39;l2&#39; , &#39;l3&#39; ] For more examples please see help for each individual functions The ~x Sigil Warning ! Because we use xmerl internally, only XPath 1.0 paths are handled. Notice in the above examples, we used the expression ~x&quot;//a/text()&quot; to define the path. The reason is it allows us to more precisely specify what is being returned. ~x&quot;//some/path&quot; without any modifiers, xpath/2 will return the value of the entity if the entity is of type xmlText , xmlAttribute , xmlPI , xmlComment as defined in :xmerl ~x&quot;//some/path&quot;e e stands for (e)ntity. This forces xpath/2 to return the entity with which you can further chain your xpath/2 call ~x&quot;//some/path&quot;l 'l' stands for (l)ist. This forces xpath/2 to return a list. Without l , xpath/2 will only return the first element of the match ~x&quot;//some/path&quot;el - mix of the above ~x&quot;//some/path&quot;k 'k' stands for (K)eyword. This forces xpath/2 to return a Keyword instead of a Map. ~x&quot;//some/path&quot;s 's' stands for (s)tring. This forces xpath/2 to return the value as string instead of a char list. x&quot;//some/path&quot;o 'o' stands for (O)ptional. This allows the path to not exist, and will return nil. ~x&quot;//some/path&quot;sl - string list. Notice also in the examples section, we always import SweetXml first. This makes x_sigil available in the current scope. Without it, instead of using ~x , you can do the following iex&gt; doc = &quot;&lt;h1&gt;&lt;a&gt;Some linked title&lt;/a&gt;&lt;/h1&gt;&quot; iex&gt; doc |&gt; SweetXml . xpath ( % SweetXpath { path : &#39;//a/text()&#39; , is_value : true , cast_to : false , is_list : false , is_keyword : false } ) &#39;Some linked title&#39; Note the use of char_list in the path definition.","ref":"SweetXml.html","title":"SweetXml","type":"module"},{"doc":"","ref":"SweetXml.html#add_namespace/3","title":"SweetXml.add_namespace/3","type":"function"},{"doc":"Parse a document into a form ready to be used by xpath/3 and xmap/2 . doc can be a byte list (iodata) a binary any enumerable of binaries (for instance File.stream!/3 result) options can be both: xmerl 's options as described on the xmerl_scan documentation page, see the erlang tutorial for some advanced usage. For example: parse(doc, quiet: true) :dtd to prevent DTD parsing or fetching, with the following possibilities: :none , will prevent both internal and external entities, it is the recommended options on untrusted XML. This will override the option {:rules, read_fun, write_fun, state} if present; :all , the default, for backward compatibility, allows all DTDs; :internal_only , will block all attempt at external fetching; [only: entities] where entities is either an atom for a single entity, or a list of atoms. If any other entity is defined in the XML, parse will raise on them. This will override the option {:rules, read_fun, write_fun, state} if present. When doc is an enumerable, the :cont_fun option cannot be given. Returns an xmlElement record.","ref":"SweetXml.html#parse/2","title":"SweetXml.parse/2","type":"function"},{"doc":"sigil_x/2 simply returns a %SweetXpath{} struct, with modifiers converted to boolean fields: iex&gt; SweetXml . sigil_x ( &quot;//some/path&quot; , &#39;e&#39; ) % SweetXpath { path : &#39;//some/path&#39; , is_value : false , cast_to : false , is_list : false , is_keyword : false } Or you can simply import and use the ~x expression: iex&gt; import SweetXml iex&gt; ~x&quot;//some/path&quot;e % SweetXpath { path : &#39;//some/path&#39; , is_value : false , cast_to : false , is_list : false , is_keyword : false } Valid modifiers are e , s , l and k . Below is the full explanation ~x&quot;//some/path&quot; without any modifiers, xpath/2 will return the value of the entity if the entity is of type xmlText , xmlAttribute , xmlPI , xmlComment as defined in :xmerl ~x&quot;//some/path&quot;e e stands for (e)ntity. This forces xpath/2 to return the entity with which you can further chain your xpath/2 call ~x&quot;//some/path&quot;l 'l' stands for (l)ist. This forces xpath/2 to return a list. Without l , xpath/2 will only return the first element of the match ~x&quot;//some/path&quot;el - mix of the above ~x&quot;//some/path&quot;k 'k' stands for (K)eyword. This forces xpath/2 to return a Keyword instead of a Map. ~x&quot;//some/path&quot;s 's' stands for (s)tring. This forces xpath/2 to return the value as string instead of a char list. x&quot;//some/path&quot;o 'o' stands for (O)ptional. This allows the path to not exist, and will return nil. ~x&quot;//some/path&quot;sl - string list. ~x&quot;//some/path&quot;i 'i' stands for (i)nteger. This forces xpath/2 to return the value as integer instead of a char list. ~x&quot;//some/path&quot;f 'f' stands for (f)loat. This forces xpath/2 to return the value as float instead of a char list. ~x&quot;//some/path&quot;il - integer list","ref":"SweetXml.html#sigil_x/2","title":"SweetXml.sigil_x/2","type":"function"},{"doc":"Equivalent to stream/2 , see stream/2 for more details. The difference is in the handling of the errors. The caller can use try/1 , whereas with stream/3 trapping exits and handling messages was necessary. May raise SweetXml.XmerlFatal or SweetXml.DTDError .","ref":"SweetXml.html#stream!/2","title":"SweetXml.stream!/2","type":"function"},{"doc":"Soft Deprecation Will be later deprecated in favor of stream!/2 . Create an element stream from a XML doc . This is a lower level API compared to SweetXml.stream_tags . You can use the options_callback argument to get fine control of what data to be streamed. doc is an enumerable, data will be pulled during the result stream enumeration. e.g. File.stream!(&quot;some_file.xml&quot;) options_callback is an anonymous function fn emit -&gt; (xmerl_opts | opts) use it to define your :xmerl callbacks and put data into the stream using emit.(elem) in the callbacks. More details are available with parse/2 . For example, here you define a stream of all xmlElement : iex&gt; import Record iex&gt; doc = [ &quot;&lt;h1&quot; , &quot;&gt;&lt;a&gt;Som&quot; , &quot;e linked title&lt;/a&gt;&lt;a&gt;other&lt;/a&gt;&lt;/h1&gt;&quot; ] iex&gt; SweetXml . stream ( doc , fn emit -&gt; ...&gt; [ ...&gt; hook_fun : fn ...&gt; entity , xstate when is_record ( entity , :xmlElement ) -&gt; ...&gt; emit . ( entity ) ...&gt; { entity , xstate } ...&gt; entity , xstate -&gt; ...&gt; { entity , xstate } ...&gt; end ...&gt; ] ...&gt; end ) |&gt; Enum . count 3","ref":"SweetXml.html#stream/2","title":"SweetXml.stream/2","type":"function"},{"doc":"Equivalent to stream_tags/3 , see stream_tags/3 for more details. The difference is in the handling of the errors. The caller can use try/1 , whereas with stream_tags/3 trapping exits and handling messages was necessary. May raise SweetXml.XmerlFatal or SweetXml.DTDError .","ref":"SweetXml.html#stream_tags!/3","title":"SweetXml.stream_tags!/3","type":"function"},{"doc":"Soft Deprecation Will be later deprecated in favor of stream_tags!/3 . Most common usage of streaming: stream a given tag or a list of tags, and optionally &quot;discard&quot; some DOM elements in order to free memory during streaming for big files which cannot fit entirely in memory. Note that each matched tag produces it's own tree. If a given tag appears in the discarded options, it is ignored. doc is an enumerable, data will be pulled during the result stream enumeration. e.g. File.stream!(&quot;some_file.xml&quot;) tags is an atom or a list of atoms you want to extract. Each stream element will be {:tagname, xmlelem} . e.g. :li, :header options[:discard] is the list of tag which will be discarded: not added to its parent DOM. More options details are available with parse/2 . Examples iex&gt; import SweetXml iex&gt; doc = [ &quot;&lt;ul&gt;&lt;li&gt;l1&lt;/li&gt;&lt;li&gt;l2&quot; , &quot;&lt;/li&gt;&lt;li&gt;l3&lt;/li&gt;&lt;/ul&gt;&quot; ] iex&gt; SweetXml . stream_tags ( doc , :li , discard : [ :li ] ) ...&gt; |&gt; Stream . map ( fn { :li , doc } -&gt; doc |&gt; SweetXml . xpath ( ~x&quot;./text()&quot; ) end ) ...&gt; |&gt; Enum . to_list [ &#39;l1&#39; , &#39;l2&#39; , &#39;l3&#39; ] iex&gt; SweetXml . stream_tags ( doc , [ :ul , :li ] ) ...&gt; |&gt; Stream . map ( fn { _ , doc } -&gt; doc |&gt; SweetXml . xpath ( ~x&quot;./text()&quot; ) end ) ...&gt; |&gt; Enum . to_list [ &#39;l1&#39; , &#39;l2&#39; , &#39;l3&#39; , nil ] Be careful if you set options[:discard] . If any of the discarded tags is nested inside a kept tag, you will not be able to access them. Examples iex&gt; import SweetXml iex&gt; doc = [ &quot;&lt;header&gt;&quot; , &quot;&lt;title&gt;XML&lt;/title&quot; , &quot;&gt;&lt;header&gt;&lt;title&gt;Nested&lt;/title&gt;&lt;/header&gt;&lt;/header&gt;&quot; ] iex&gt; SweetXml . stream_tags ( doc , :header ) ...&gt; |&gt; Stream . map ( fn { _ , doc } -&gt; SweetXml . xpath ( doc , ~x&quot;.//title/text()&quot; ) end ) ...&gt; |&gt; Enum . to_list [ &#39;Nested&#39; , &#39;XML&#39; ] iex&gt; SweetXml . stream_tags ( doc , :header , discard : [ :title ] ) ...&gt; |&gt; Stream . map ( fn { _ , doc } -&gt; SweetXml . xpath ( doc , ~x&quot;./title/text()&quot; ) end ) ...&gt; |&gt; Enum . to_list [ nil , nil ]","ref":"SweetXml.html#stream_tags/3","title":"SweetXml.stream_tags/3","type":"function"},{"doc":"Tags %SweetXpath{} with fun to be applied at the end of xpath query. Examples iex&gt; import SweetXml iex&gt; string_to_range = fn str -&gt; ...&gt; [ first , last ] = str |&gt; String . split ( &quot;-&quot; , trim : true ) |&gt; Enum . map ( &amp; String . to_integer / 1 ) ...&gt; first .. last ...&gt; end iex&gt; doc = &quot;&lt;weather&gt;&lt;zone&gt;&lt;name&gt;north&lt;/name&gt;&lt;wind-speed&gt;5-15&lt;/wind-speed&gt;&lt;/zone&gt;&lt;/weather&gt;&quot; iex&gt; doc ...&gt; |&gt; xpath ( ...&gt; ~x&quot;//weather/zone&quot;l , ...&gt; name : ~x&quot;//name/text()&quot;s |&gt; transform_by ( &amp; String . capitalize / 1 ) , ...&gt; wind_speed : ~x&quot;./wind-speed/text()&quot;s |&gt; transform_by ( string_to_range ) ...&gt; ) [ %{ name : &quot;North&quot; , wind_speed : 5 .. 15 } ]","ref":"SweetXml.html#transform_by/2","title":"SweetXml.transform_by/2","type":"function"},{"doc":"xmap returns a mapping with each value being the result of xpath . Just as xpath , you can nest the mapping structure. Please see xpath/3 for more detail. You can give the option true to get the result as a keyword list instead of a map. Examples Simple: iex&gt; import SweetXml iex&gt; doc = &quot;&lt;h1&gt;&lt;a&gt;Some linked title&lt;/a&gt;&lt;/h1&gt;&quot; iex&gt; doc |&gt; xmap ( a : ~x&quot;//a/text()&quot; ) %{ a : &#39;Some linked title&#39; } With optional mapping: iex&gt; import SweetXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc |&gt; xmap ( message : ~x&quot;//p/text()&quot; , a_in_li : ~x&quot;.//li/a/text()&quot;l ) %{ a_in_li : [ &#39;Two&#39; ] , message : &#39;Message&#39; } With optional mapping and nesting: iex&gt; import SweetXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc ...&gt; |&gt; xmap ( ...&gt; message : ~x&quot;//p/text()&quot; , ...&gt; ul : [ ...&gt; ~x&quot;//ul&quot; , ...&gt; a : ~x&quot;./li/a/text()&quot; ...&gt; ] ...&gt; ) %{ message : &#39;Message&#39; , ul : %{ a : &#39;Two&#39; } } iex&gt; doc ...&gt; |&gt; xmap ( ...&gt; message : ~x&quot;//p/text()&quot; , ...&gt; ul : [ ...&gt; ~x&quot;//ul&quot;k , ...&gt; a : ~x&quot;./li/a/text()&quot; ...&gt; ] ...&gt; ) %{ message : &#39;Message&#39; , ul : [ a : &#39;Two&#39; ] } iex&gt; doc ...&gt; |&gt; xmap ( [ ...&gt; message : ~x&quot;//p/text()&quot; , ...&gt; ul : [ ...&gt; ~x&quot;//ul&quot; , ...&gt; a : ~x&quot;./li/a/text()&quot; ...&gt; ] ...&gt; ] , true ) [ message : &#39;Message&#39; , ul : %{ a : &#39;Two&#39; } ] Security Whenever you are working with some xml that was not generated by your system, it is highly recommended that you restrain some functionalities of XML during the parsing. SweetXml allows in particular to prevent DTD parsing and fetching. Unless you know exactly what kind of DTD you want to permit in your xml, it is recommended that you use the following code example to prevent possible attacks: doc |&gt; parse ( dtd : :none ) |&gt; xmap ( specs , options ) For more details, see parse/2 .","ref":"SweetXml.html#xmap/3","title":"SweetXml.xmap/3","type":"function"},{"doc":"","ref":"SweetXml.html#xmlAttribute/2","title":"SweetXml.xmlAttribute/2","type":"macro"},{"doc":"","ref":"SweetXml.html#xmlComment/2","title":"SweetXml.xmlComment/2","type":"macro"},{"doc":"","ref":"SweetXml.html#xmlDecl/2","title":"SweetXml.xmlDecl/2","type":"macro"},{"doc":"","ref":"SweetXml.html#xmlDocument/2","title":"SweetXml.xmlDocument/2","type":"macro"},{"doc":"","ref":"SweetXml.html#xmlElement/2","title":"SweetXml.xmlElement/2","type":"macro"},{"doc":"","ref":"SweetXml.html#xmlNamespace/2","title":"SweetXml.xmlNamespace/2","type":"macro"},{"doc":"","ref":"SweetXml.html#xmlNsNode/2","title":"SweetXml.xmlNsNode/2","type":"macro"},{"doc":"","ref":"SweetXml.html#xmlObj/2","title":"SweetXml.xmlObj/2","type":"macro"},{"doc":"","ref":"SweetXml.html#xmlPI/2","title":"SweetXml.xmlPI/2","type":"macro"},{"doc":"","ref":"SweetXml.html#xmlText/2","title":"SweetXml.xmlText/2","type":"macro"},{"doc":"xpath allows you to query an XML document with XPath. The second argument to xpath is a %SweetXpath{} struct. The optional third argument is a keyword list, such that the value of each keyword is also either a %SweetXpath{} or a list with head being a %SweetXpath{} and tail being another keyword list exactly like before. Please see the examples below for better understanding. Examples Simple: iex&gt; import SweetXml iex&gt; doc = &quot;&lt;h1&gt;&lt;a&gt;Some linked title&lt;/a&gt;&lt;/h1&gt;&quot; iex&gt; doc |&gt; xpath ( ~x&quot;//a/text()&quot; ) &#39;Some linked title&#39; With optional mapping: iex&gt; import SweetXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc |&gt; xpath ( ~x&quot;//header&quot; , message : ~x&quot;./p/text()&quot; , a_in_li : ~x&quot;.//li/a/text()&quot;l ) %{ a_in_li : [ &#39;Two&#39; ] , message : &#39;Message&#39; } With optional mapping and nesting: iex&gt; import SweetXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc ...&gt; |&gt; xpath ( ...&gt; ~x&quot;//header&quot; , ...&gt; ul : [ ...&gt; ~x&quot;./ul&quot; , ...&gt; a : ~x&quot;./li/a/text()&quot; ...&gt; ] ...&gt; ) %{ ul : %{ a : &#39;Two&#39; } } Security Whenever you are working with some xml that was not generated by your system, it is highly recommended that you restrain some functionalities of XML during the parsing. SweetXml allows in particular to prevent DTD parsing and fetching. Unless you know exactly what kind of DTD you want to permit in your xml, it is recommended that you use the following code example to prevent possible attacks: doc |&gt; parse ( dtd : :none ) |&gt; xpath ( spec , subspec ) For more details, see parse/2 .","ref":"SweetXml.html#xpath/3","title":"SweetXml.xpath/3","type":"function"},{"doc":"","ref":"SweetXml.html#t:doc/0","title":"SweetXml.doc/0","type":"type"},{"doc":"","ref":"SweetXml.html#t:spec/0","title":"SweetXml.spec/0","type":"type"},{"doc":"","ref":"SweetXml.html#t:xmlElement/0","title":"SweetXml.xmlElement/0","type":"type"},{"doc":"An error raised when a non allowed DTD is encountered.","ref":"SweetXml.DTDError.html","title":"SweetXml.DTDError","type":"exception"},{"doc":"An error raised when xmerl exits with a fatal error.","ref":"SweetXml.XmerlFatal.html","title":"SweetXml.XmerlFatal","type":"exception"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Changed Contribution from @thbar : Logger deprecation warning fixed for Elixir 1.15 ( #94 ) Now requires Elixir 1.12+ ( #94 )","ref":"changelog.html#0-7-4","title":"Changelog - 0.7.4","type":"extras"},{"doc":"Changed Handling the option {:rules, _} ourselve, as well as partially the option {:rules, _, _, _} . When nothing is given, a new table is created, and destroyed after. If a table is given, and a DTD option is chosen, the table is reused for the DTD handling. If a custom {:rules, _, _, _} is given, and a restrictive DTD option is chosen, the custome rule will be overriden. Because of this mutual exclusivity (reconciling the behaviors is not possible via composition), it is recommended that you handle the DTD problem by yourself. You can see the issue #71 for ideas. See the issue #41 for more details on why this change happened. (Ets leaks.)","ref":"changelog.html#0-7-3-2022-04-11","title":"Changelog - 0.7.3 (2022-04-11)","type":"extras"},{"doc":"Changed Improvement on the doc, notably warning that only XPath 1.0 queries are handled. Added Contribution from @tank-bohr : Added strict stream API with a more coherent overall behavior, and easier to handle failure behavior: stream!/2 and stream_tags!/2,3 are now available.","ref":"changelog.html#0-7-2-2021-11-25","title":"Changelog - 0.7.2 (2021-11-25)","type":"extras"},{"doc":"Changed @J3RN noticed a breaking change due to the introduction of an opaque type Changed xmlElement from @opaque to @type","ref":"changelog.html#0-7-1-2021-08-25","title":"Changelog - 0.7.1 (2021-08-25)","type":"extras"},{"doc":"Changed Improvement on the doc Added Added option to raise on DTD definitions","ref":"changelog.html#0-7-0-2021-07-02","title":"Changelog - 0.7.0 (2021-07-02)","type":"extras"},{"doc":"small bugfix: Fix compilation warnings on newer versions of Elixir doc updates","ref":"changelog.html#0-6-6-2019-02-24","title":"Changelog - 0.6.6 (2019-02-24)","type":"extras"},{"doc":"small bugfix : unexpected :halted of enumerable","ref":"changelog.html#0-6-5-2017-02-08","title":"Changelog - 0.6.5 (2017-02-08)","type":"extras"},{"doc":"make it compatible with Elixir 1.4","ref":"changelog.html#0-6-4-2017-01-17","title":"Changelog - 0.6.4 (2017-01-17)","type":"extras"},{"doc":"bugfix: xpath optional with cast and void should return nil add &quot;soft&quot; uppercase cast modifier : put default value if type modifier is uppercase &quot;&quot;,0,0.0 if &quot;soft&quot; and &quot;optional&quot;, then return nil with value not compatible","ref":"changelog.html#0-6-3-2016-12-14","title":"Changelog - 0.6.3 (2016-12-14)","type":"extras"},{"doc":"bugfix: xpath list modifier should always return a list","ref":"changelog.html#0-6-1-2016-02-10","title":"Changelog - 0.6.1 (2016-02-10)","type":"extras"},{"doc":"text() XML nodes are now joined with the s modifier transform_by function allows you to customize each mapped field with any function","ref":"changelog.html#0-6-0-2016-02-09","title":"Changelog - 0.6.0 (2016-02-09)","type":"extras"},{"doc":"","ref":"changelog.html#0-5-1-2016-02-08","title":"Changelog - 0.5.1 (2016-02-08)","type":"extras"},{"doc":"Added support to optional modifier Update Elixir requirement Map refactoring, from if/else tree to cleaner pattern matching Add casting capabilities Fix dependencies : doc deps only for :dev and OTP :xmerl dependency","ref":"changelog.html#0-5-0-2015-10-28","title":"Changelog - 0.5.0 (2015-10-28)","type":"extras"},{"doc":"Added support to map into keyword list instead of maps","ref":"changelog.html#0-4-0-2015-09-11","title":"Changelog - 0.4.0 (2015-09-11)","type":"extras"},{"doc":"Added support to return values as strings (viniciussbs) Fix stream :halt handling (awetzel)","ref":"changelog.html#0-3-0-2015-08-10","title":"Changelog - 0.3.0 (2015-08-10)","type":"extras"},{"doc":"","ref":"changelog.html#0-2-1-2016-04-12","title":"Changelog - 0.2.1 (2016-04-12)","type":"extras"},{"doc":"Fixed encoding issue and improved speed (awetzel) Added file streaming support (awetzel) Added element streaming (awetzel) Added support for scalar values (xbrukner)","ref":"changelog.html#0-2-0-2016-04-11","title":"Changelog - 0.2.0 (2016-04-11)","type":"extras"},{"doc":"Changelog format inspired by keep-a-changelog","ref":"changelog.html#0-1-1","title":"Changelog - 0.1.1","type":"extras"},{"doc":"SweetXml is a thin wrapper around :xmerl . It allows you to convert a char_list or xmlElement record as defined in :xmerl to an elixir value such as map , list , string , integer , float or any combination of these.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add dependency to your project's mix.exs : def deps do [ { :sweet_xml , &quot;~&gt; 0.7.1&quot; } ] end SweetXml depends on :xmerl . On some Linux systems, you might need to install the package erlang-xmerl .","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Given an XML document such as below: &lt;?xml version=&quot;1.05&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;game&gt; &lt;matchups&gt; &lt;matchup winner-id=&quot;1&quot;&gt; &lt;name&gt;Match One&lt;/name&gt; &lt;teams&gt; &lt;team&gt; &lt;id&gt;1&lt;/id&gt; &lt;name&gt;Team One&lt;/name&gt; &lt;/team&gt; &lt;team&gt; &lt;id&gt;2&lt;/id&gt; &lt;name&gt;Team Two&lt;/name&gt; &lt;/team&gt; &lt;/teams&gt; &lt;/matchup&gt; &lt;matchup winner-id=&quot;2&quot;&gt; &lt;name&gt;Match Two&lt;/name&gt; &lt;teams&gt; &lt;team&gt; &lt;id&gt;2&lt;/id&gt; &lt;name&gt;Team Two&lt;/name&gt; &lt;/team&gt; &lt;team&gt; &lt;id&gt;3&lt;/id&gt; &lt;name&gt;Team Three&lt;/name&gt; &lt;/team&gt; &lt;/teams&gt; &lt;/matchup&gt; &lt;matchup winner-id=&quot;1&quot;&gt; &lt;name&gt;Match Three&lt;/name&gt; &lt;teams&gt; &lt;team&gt; &lt;id&gt;1&lt;/id&gt; &lt;name&gt;Team One&lt;/name&gt; &lt;/team&gt; &lt;team&gt; &lt;id&gt;3&lt;/id&gt; &lt;name&gt;Team Three&lt;/name&gt; &lt;/team&gt; &lt;/teams&gt; &lt;/matchup&gt; &lt;/matchups&gt; &lt;/game&gt; We can do the following: import SweetXml doc = &quot;...&quot; # as above Get the name of the first match: result = doc |&gt; xpath ( ~x&quot;//matchup/name/text()&quot; ) # `sigil_x` for (x)path assert result == &#39;Match One&#39; Get the XML record of the name of the first match: result = doc |&gt; xpath ( ~x&quot;//matchup/name&quot;e ) # `e` is the modifier for (e)ntity assert result == { :xmlElement , :name , :name , [ ] , { :xmlNamespace , [ ] , [ ] } , [ matchup : 2 , matchups : 2 , game : 1 ] , 2 , [ ] , [ { :xmlText , [ name : 2 , matchup : 2 , matchups : 2 , game : 1 ] , 1 , [ ] , &#39;Match One&#39; , :text } ] , [ ] , ... } Get the full list of matchup name: result = doc |&gt; xpath ( ~x&quot;//matchup/name/text()&quot;l ) # `l` stands for (l)ist assert result == [ &#39;Match One&#39; , &#39;Match Two&#39; , &#39;Match Three&#39; ] Get a list of winner-id by attributes: result = doc |&gt; xpath ( ~x&quot;//matchup/@winner-id&quot;l ) assert result == [ &#39;1&#39; , &#39;2&#39; , &#39;1&#39; ] Get a list of matchups with different map structure: result = doc |&gt; xpath ( ~x&quot;//matchups/matchup&quot;l , name : ~x&quot;./name/text()&quot; , winner : [ ~x&quot;.//team/id[.=ancestor::matchup/@winner-id]/..&quot; , name : ~x&quot;./name/text()&quot; ] ) assert result == [ %{ name : &#39;Match One&#39; , winner : %{ name : &#39;Team One&#39; } } , %{ name : &#39;Match Two&#39; , winner : %{ name : &#39;Team Two&#39; } } , %{ name : &#39;Match Three&#39; , winner : %{ name : &#39;Team One&#39; } } ] Or directly return a mapping of your liking: result = doc |&gt; xmap ( matchups : [ ~x&quot;//matchups/matchup&quot;l , name : ~x&quot;./name/text()&quot; , winner : [ ~x&quot;.//team/id[.=ancestor::matchup/@winner-id]/..&quot; , name : ~x&quot;./name/text()&quot; ] ] , last_matchup : [ ~x&quot;//matchups/matchup[last()]&quot; , name : ~x&quot;./name/text()&quot; , winner : [ ~x&quot;.//team/id[.=ancestor::matchup/@winner-id]/..&quot; , name : ~x&quot;./name/text()&quot; ] ] ) assert result == %{ matchups : [ %{ name : &#39;Match One&#39; , winner : %{ name : &#39;Team One&#39; } } , %{ name : &#39;Match Two&#39; , winner : %{ name : &#39;Team Two&#39; } } , %{ name : &#39;Match Three&#39; , winner : %{ name : &#39;Team One&#39; } } ] , last_matchup : %{ name : &#39;Match Three&#39; , winner : %{ name : &#39;Team One&#39; } } }","ref":"readme.html#examples","title":"Overview - Examples","type":"extras"},{"doc":"Warning ! Because we use xmerl internally, only XPath 1.0 paths are handled. In the above examples, we used the expression ~x&quot;//some/path&quot; to define the path. The reason is it allows us to more precisely specify what is being returned. ~x&quot;//some/path&quot; without any modifiers, xpath/2 will return the value of the entity if the entity is of type xmlText , xmlAttribute , xmlPI , xmlComment as defined in :xmerl ~x&quot;//some/path&quot;e e stands for (e)ntity. This forces xpath/2 to return the entity with which you can further chain your xpath/2 call ~x&quot;//some/path&quot;l 'l' stands for (l)ist. This forces xpath/2 to return a list. Without l , xpath/2 will only return the first element of the match ~x&quot;//some/path&quot;k 'k' stands for (k)eyword. This forces xpath/2 to return a Keyword instead of a Map. ~x&quot;//some/path&quot;el - mix of the above ~x&quot;//some/path&quot;s 's' stands for (s)tring. This forces xpath/2 to return the value as string instead of a char list. ~x&quot;//some/path&quot;S 'S' stands for soft (S)tring. This forces xpath/2 to return the value as string instead of a char list, but if node content is incompatible with a string, set &quot;&quot; . ~x&quot;//some/path&quot;o 'o' stands for (o)ptional. This allows the path to not exist, and will return nil. ~x&quot;//some/path&quot;sl - string list. ~x&quot;//some/path&quot;i 'i' stands for (i)nteger. This forces xpath/2 to return the value as integer instead of a char list. ~x//some/path&quot;I 'I' stands for soft (I)nteger. This forces xpath/2 to return the value as integer instead of a char list, but if node content is incompatible with an integer, set 0 . ~x&quot;//some/path&quot;f 'f' stands for (f)loat. This forces xpath/2 to return the value as float instead of a char list. ~x//some/path&quot;F 'F' stands for soft (F)loat. This forces xpath/2 to return the value as float instead of a char list, but if node content is incompatible with a float, set 0.0 . ~x&quot;//some/path&quot;il - integer list. If you use the optional modifier o together with a soft cast modifier (uppercase), then the value is set to nil when the value is not compatible for instance ~x//some/path/text()&quot;Fo return nil if the text is not a number. Also in the examples section, we always import SweetXml first. This makes x_sigil available in the current scope. Without it, instead of using ~x , you can use the %SweetXpath struct assert ~x&quot;//some/path&quot;e == % SweetXpath { path : &#39;//some/path&#39; , is_value : false , is_list : false , cast_to : false } Note the use of char_list in the path definition.","ref":"readme.html#the-x-sigil","title":"Overview - The ~x Sigil","type":"extras"},{"doc":"Given a XML document such as below &lt;?xml version=&quot;1.05&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;game xmlns=&quot;http://example.com/fantasy-league&quot; xmlns:ns1=&quot;http://example.com/baseball-stats&quot;&gt; &lt;matchups&gt; &lt;matchup winner-id=&quot;1&quot;&gt; &lt;name&gt;Match One&lt;/name&gt; &lt;teams&gt; &lt;team&gt; &lt;id&gt;1&lt;/id&gt; &lt;name&gt;Team One&lt;/name&gt; &lt;ns1:runs&gt;5&lt;/ns1:runs&gt; &lt;/team&gt; &lt;team&gt; &lt;id&gt;2&lt;/id&gt; &lt;name&gt;Team Two&lt;/name&gt; &lt;ns1:runs&gt;2&lt;/ns1:runs&gt; &lt;/team&gt; &lt;/teams&gt; &lt;/matchup&gt; &lt;/matchups&gt; &lt;/game&gt; We can do the following: import SweetXml xml_str = &quot;...&quot; # as above doc = parse ( xml_str , namespace_conformant : true ) Note the fact that we explicitly parse the XML with the namespace_conformant: true option. This is needed to allow nodes to be identified in a prefix independent way. We can use namespace prefixes of our preference, regardless of what prefix is used in the document: result = doc |&gt; xpath ( ~x&quot;//ff:matchup/ff:name/text()&quot; |&gt; add_namespace ( &quot;ff&quot; , &quot;http://example.com/fantasy-league&quot; ) ) assert result == &#39;Match One&#39; We can specify multiple namespace prefixes: result = doc |&gt; xpath ( ~x&quot;//ff:matchup//bb:runs/text()&quot; |&gt; add_namespace ( &quot;ff&quot; , &quot;http://example.com/fantasy-league&quot; ) |&gt; add_namespace ( &quot;bb&quot; , &quot;http://example.com/baseball-stats&quot; ) ) assert result == &#39;5&#39;","ref":"readme.html#namespace-support","title":"Overview - Namespace support","type":"extras"},{"doc":"Here's a brief explanation to how nesting came about. Chaining Both xpath and xmap can take an :xmerl XML record as the first argument. Therefore you can chain calls to these functions like below: doc |&gt; xpath ( ~x&quot;//li&quot;l ) |&gt; Enum . map fn ( li_node ) -&gt; %{ name : li_node |&gt; xpath ( ~x&quot;./name/text()&quot; ) , age : li_node |&gt; xpath ( ~x&quot;./age/text()&quot; ) } end Mapping to a structure Since the previous example is such a common use case, SweetXml allows you just simply do the following doc |&gt; xpath ( ~x&quot;//li&quot;l , name : ~x&quot;./name/text()&quot; , age : ~x&quot;./age/text()&quot; ) Nesting But what you want is sometimes more complex than just that, SweetXml thus also allows nesting doc |&gt; xpath ( ~x&quot;//li&quot;l , name : [ ~x&quot;./name&quot; , first : ~x&quot;./first/text()&quot; , last : ~x&quot;./last/text()&quot; ] , age : ~x&quot;./age/text()&quot; ) Transform By Sometimes we need to transform the value to what we need, SweetXml supports that via transform_by/2 doc = &quot;&lt;li&gt;&lt;name&gt;&lt;first&gt;john&lt;/first&gt;&lt;last&gt;doe&lt;/last&gt;&lt;/name&gt;&lt;age&gt;30&lt;/age&gt;&lt;/li&gt;&quot; result = doc |&gt; xpath ( ~x&quot;//li&quot;l , name : [ ~x&quot;./name&quot; , first : ~x&quot;./first/text()&quot;s |&gt; transform_by ( &amp; String . capitalize / 1 ) , last : ~x&quot;./last/text()&quot;s |&gt; transform_by ( &amp; String . capitalize / 1 ) ] , age : ~x&quot;./age/text()&quot;i ) ^ result = [ %{ age : 30 , name : %{ first : &quot;John&quot; , last : &quot;Doe&quot; } } ] The same can be used to break parsing code into reusable functions that can be used in nesting: doc = &quot;&lt;li&gt;&lt;name&gt;&lt;first&gt;john&lt;/first&gt;&lt;last&gt;doe&lt;/last&gt;&lt;/name&gt;&lt;age&gt;30&lt;/age&gt;&lt;/li&gt;&quot; parse_name = fn xpath_node -&gt; xpath_node |&gt; xmap ( first : ~x&quot;./first/text()&quot;s |&gt; transform_by ( &amp; String . capitalize / 1 ) , last : ~x&quot;./last/text()&quot;s |&gt; transform_by ( &amp; String . capitalize / 1 ) ) end result = doc |&gt; xpath ( ~x&quot;//li&quot;l , name : ~x&quot;./name&quot; |&gt; transform_by ( parse_name ) , age : ~x&quot;./age/text()&quot;i ) ^ result = [ %{ age : 30 , name : %{ first : &quot;John&quot; , last : &quot;Doe&quot; } } ] For more examples, please take a look at the tests and help.","ref":"readme.html#from-chaining-to-nesting","title":"Overview - From Chaining to Nesting","type":"extras"},{"doc":"SweetXml now also supports streaming in various forms. Here's a sample XML doc. Notice the certain lines have XML tags that span multiple lines: &lt;?xml version=&quot;1.05&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;html&gt; &lt;head&gt; &lt;title&gt;XML Parsing&lt;/title&gt; &lt;head&gt;&lt;title&gt;Nested Head&lt;/title&gt;&lt;/head&gt; &lt;/head&gt; &lt;body&gt; &lt;p&gt;Neato €&lt;/p&gt;&lt;ul&gt; &lt;li class=&quot;first star&quot; data-index=&quot;1&quot;&gt; First&lt;/li&gt;&lt;li class=&quot;second&quot;&gt;Second &lt;/li&gt;&lt;li class=&quot;third&quot;&gt;Third&lt;/li&gt; &lt;/ul&gt; &lt;div&gt; &lt;ul&gt; &lt;li&gt;Forth&lt;/li&gt; &lt;/ul&gt; &lt;/div&gt; &lt;special_match_key&gt;first star&lt;/special_match_key&gt; &lt;/body&gt; &lt;/html&gt; Working with File.stream!/1 Working with streams is exactly the same as working with binaries: File . stream! ( &quot;file_above.xml&quot; ) |&gt; xpath ( ... ) SweetXml element streaming Once you have a file stream, you may not want to work with the entire document to save memory: file_stream = File . stream! ( &quot;file_above.xml&quot; ) result = file_stream |&gt; stream_tags ( [ :li , :special_match_key ] ) |&gt; Stream . map ( fn { _ , doc } -&gt; xpath ( doc , ~x&quot;./text()&quot; ) end ) |&gt; Enum . to_list assert result == [ &#39; \\n First&#39; , &#39;Second \\n &#39; , &#39;Third&#39; , &#39;Forth&#39; , &#39;first star&#39; ] Warning: In case of large document, you may want to use the discard option to avoid memory leak. result = file_stream |&gt; stream_tags ( [ :li , :special_match_key ] , discard : [ :li , :special_match_key ] )","ref":"readme.html#streaming","title":"Overview - Streaming","type":"extras"},{"doc":"Whenever you have to deal with some XML that was not generated by your system (untrusted document), it is highly recommended that you separate the parsing step from the mapping step, in order to be able to prevent some default behavior through options. You can check the doc for SweetXml.parse/2 for more details. The current recommendations are: doc |&gt; parse ( dtd : :none ) |&gt; xpath ( spec , subspec ) enum |&gt; stream_tags ( tags , dtd : :none )","ref":"readme.html#security","title":"Overview - Security","type":"extras"},{"doc":"Copyright (c) 2014, Frank Liu SweetXml source code is licensed under the MIT License . CONTRIBUTING Hi, and thank you for wanting to contribute. Please refer to the centralized informations available at: https://github.com/kbrw#contributing","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]